#include <windows.h>
#include <stdio.h>
#include "floatex.h"
#include "const_cnv.h"
#include "resource.h"

VOID		OnOK(HWND hWnd)
{
	INT				i;
	FLOATEX			val;
	LPSTR			ptr,pstop;
	CHAR			buf[512];
	BOOL			bOverflow;
	static LPSTR	perr = "lϊɎs܂B\r\n͂lƎނmFĂ";

	GetDlgItemText(hWnd,IDC_EDIT1,buf,sizeof(buf));

	if (SendDlgItemMessage(
		hWnd,IDC_RADIO1,BM_GETCHECK,0L,0L) == BST_CHECKED){ /*  */

		if (floatex_ldstr_strtold(buf,&pstop,val) || *pstop){
			MessageBox(hWnd,perr,gpszWinName,MB_OK | MB_ICONHAND);
			return;
		}
	}else if (SendDlgItemMessage(
		hWnd,IDC_RADIO2,BM_GETCHECK,0L,0L) == BST_CHECKED){ /* t */

		INT64		ival;

		ival = floatex_strtoi64(buf,&pstop,0,&bOverflow);

		if (*pstop || bOverflow == TRUE){
			MessageBox(hWnd,perr,gpszWinName,MB_OK | MB_ICONHAND);
			return;
		}

		floatex_int64to(ival,val);

	}else{ /*  */

		UINT64		uval;

		uval = floatex_strtoui64(buf,&pstop,0,&bOverflow);

		if (*pstop || bOverflow == TRUE){
			MessageBox(hWnd,perr,gpszWinName,MB_OK | MB_ICONHAND);
			return;
		}

		floatex_uint64to(uval,val);
	}

	ptr = buf + sprintf(buf,"FLOATEX\txxxxx = {");

	for(i = 0;i < FLOATEX_SIZE;i++){
		ptr += sprintf(ptr," %s%x",(val[i] > 9)? "0x" : "", val[i]);
		if (i != FLOATEX_SIZE - 1)
			*ptr++ = ',';
	}
	sprintf(ptr," };");

	SetDlgItemText(hWnd,IDC_EDIT2,buf);
	EnableWindow(GetDlgItem(hWnd,IDC_COPY),TRUE);
}
