#include <windows.h>
#include "floatex.h"
#include "const_cnv.h"
#include "resource.h"

LRESULT CALLBACK	DialogProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	PAINTSTRUCT		ps;

	switch(Msg){
		case	WM_INITDIALOG:
				SendDlgItemMessage(
					hWnd,IDC_RADIO1,BM_SETCHECK,(WPARAM)BST_CHECKED,0L);
				EnableWindow(GetDlgItem(hWnd,IDC_COPY),FALSE);
				break;

		case	WM_PAINT:
				BeginPaint(hWnd,&ps); EndPaint(hWnd,&ps);
				break;

		case	WM_CLOSE:
				EndDialog(hWnd,IDOK);
				break;

		case	WM_COMMAND:
				switch(LOWORD(wParam)){
					case	IDOK:
							OnOK(hWnd);
							break;

					case	IDC_COPY:
							copy_clipboard(hWnd);
							break;
				}
				break;
		default:
				return FALSE;
	}
	return TRUE;
}
