#include <windows.h>
#include "winctrl.h"
#include "local.h"

/* 摜Nbv{[hփRs[ */
static BOOL		capture(
					HWND		hWndOwner,
					HDC			hDC,
					HBITMAP		hBmp,
					INT			width,
					INT			height)
{
	BITMAPINFOHEADER	inf = {0};
	HANDLE				hMem;
	LPBYTE				ptr;

	inf.biSize = sizeof(BITMAPINFOHEADER);
	inf.biWidth = width;
	inf.biHeight = height;
	inf.biPlanes = 1;
	inf.biBitCount = 24;
	inf.biCompression = BI_RGB;

	/* 摜̏擾AꂽTCYŃm */
	if (!GetDIBits(hDC,hBmp,0,height,NULL,(BITMAPINFO *)&inf,DIB_RGB_COLORS) ||
		(hMem = GlobalAlloc(GMEM_DDESHARE | GMEM_ZEROINIT,
			sizeof(BITMAPINFOHEADER) + inf.biSizeImage)) == NULL)
		return FALSE;

	if ((ptr = (LPBYTE)GlobalLock(hMem)) == NULL){ /* 擪AhX */
		GlobalFree(hMem);
		return FALSE;
	}

	memcpy(ptr,&inf,sizeof(BITMAPINFOHEADER)); /* 摜 */
	ptr += sizeof(BITMAPINFOHEADER); /* rbg}bvC[W擪AhX */

	/* rbg}bvC[W̎擾ƃNbv{[h̃I[v */
	if (!GetDIBits(hDC,hBmp,0,height,ptr,(BITMAPINFO *)&inf,DIB_RGB_COLORS) ||
		OpenClipboard(hWndOwner) == FALSE){
		GlobalFree(hMem);
		return FALSE;
	}

	/* Nbv{[hɂA摜Ŝn */
	if (EmptyClipboard() == FALSE || !SetClipboardData(CF_DIB,hMem)){
		GlobalFree(hMem);
		CloseClipboard();
		return FALSE;
	}

	GlobalUnlock(hMem);
	CloseClipboard();

	return TRUE;
}

/* 摜Nbv{[hփRs[ */
VOID	OnCapture(HWND hWnd)
{
	SuspendThread(ghThread); /* Ôߕ`Xbh~Ă܂ */

	if (capture(hWnd,ghDC,ghBmp,gnWidth,gnHeight) != FALSE)
		MessageBeep(MB_OK); /* 特o */

	ResumeThread(ghThread); /* `XbhĊJ */
}
