#include <windows.h>
#include "winctrl.h"
#include "local.h"

/* EChEƃXbh̍쐬 */
static  INT		local_startwnd(
					HINSTANCE		hInst,
					HWND			hWndOwner,
					LPSTR			pszWinTitle,
					INT				nWidth,
					INT				nHeight,
					DRAW_ROUTINE	pdraw)
{
	HWND		hWnd;
	WNDCLASS	wc;
	MSG			m;
	RECT		rect;

	gpfDraw = pdraw;

	wc.hInstance = hInst;
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.lpfnWndProc = (WNDPROC)WindowProc;
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName = wc.lpszMenuName = pszWinTitle;
	wc.cbClsExtra = wc.cbWndExtra = 0;
	wc.style = 0; wc.hIcon = NULL;

	#define STYLE_DISABLE	(WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX)
	#define WINSTYLE		(WS_OVERLAPPEDWINDOW ^ STYLE_DISABLE)

	rect.top = rect.left = 0;
	gnWidth = rect.right = nWidth;
	gnHeight = rect.bottom = nHeight;

	AdjustWindowRect(&rect,WINSTYLE,FALSE); /* EChETCY̒ */
	if (!RegisterClass(&wc)) /* EChENX */
		return 0;

	InitializeCriticalSection(&gcs);

	/* EChE̍쐬 */
	hWnd = CreateWindow(
				pszWinTitle,
				pszWinTitle,
				WINSTYLE,
				0,0,WIDTH(rect),HEIGHT(rect),
				hWndOwner,
				NULL,
				wc.hInstance,
				NULL);
	if (hWnd == NULL){
		DeleteCriticalSection(&gcs);
		return 0;
	}

	ShowWindow(hWnd,SW_SHOW);
	UpdateWindow(hWnd);

	while(GetMessage(&m,NULL,0,0)){ /* bZ[W[v */
		TranslateMessage(&m);
		DispatchMessage(&m);
	}

	DeleteCriticalSection(&gcs);

	return m.wParam;
}

WC_DECLARE INT __stdcall	StartWindow(
								HINSTANCE		hInst,
								HWND			hWndOwner,
								LPSTR			pszWinTitle,
								DRAW_ROUTINE	pdraw)
{
	return local_startwnd(
				hInst,
				hWndOwner,
				pszWinTitle,
				WIN_WIDTH,
				WIN_HEIGHT,
				pdraw);
}

WC_DECLARE INT __stdcall	StartWindowEx(
								HINSTANCE		hInst,
								HWND			hWndOwner,
								LPSTR			pszWinTitle,
								INT				nWidth,
								INT				nHeight,
								DRAW_ROUTINE	pdraw)
{
	return local_startwnd(
				hInst,
				hWndOwner,
				pszWinTitle,
				nWidth,
				nHeight,
				pdraw);
}
