#include <windows.h>
#include "winctrl.h"
#include "local.h"

/* |bvAbvj[̍쐬 */
HMENU		MakePopupMenu(PMENUITEM ptbl,INT max)
{
	INT				i;
	HMENU			hMenu;
	MENUITEMINFO	mi;

	if ((hMenu = CreatePopupMenu()) == NULL)
		return NULL;

	mi.cbSize = sizeof(MENUITEMINFO);
	mi.fState = MFS_ENABLED;

	for(i = 0;i < max;i++,ptbl++){
		if (!ptbl->pstr){			/* Zp[^ */
			mi.fMask = MIIM_TYPE;
			mi.fType = MFT_SEPARATOR;
			if (ptbl->wID){
				mi.fMask |= MIIM_ID;
				mi.wID = ptbl->wID;
			}
		}else{
			mi.fMask = MIIM_TYPE | MIIM_STATE;
			if (ptbl->hSubMenu){	/* Tuj[ */
				mi.fMask |= MIIM_SUBMENU;
				if (ptbl->wID){
					mi.fMask |= MIIM_ID;
					mi.wID = ptbl->wID;
				}
				mi.hSubMenu = ptbl->hSubMenu;
			}else{
				mi.fMask |= MIIM_ID;
				mi.wID = ptbl->wID;
			}
			mi.fType = MFT_STRING;
			mi.dwTypeData = ptbl->pstr;
			mi.cch = strlen(mi.dwTypeData);
		}

		InsertMenuItem(hMenu,i,TRUE,&mi);
	}

	return hMenu;
}
