#include "cfloatex.h"

int			CFloatEX::operator==(const CFloatEX &n)
{
	return !floatex_comp(val,(PFLOATEX)n.val);
}

int			CFloatEX::operator!=(const CFloatEX &n)
{
	return !(*this == n);
}

int			CFloatEX::operator<(const CFloatEX &n)
{
	return floatex_comp(val,(PFLOATEX)n.val) < 0;
}

int			CFloatEX::operator>(const CFloatEX &n)
{
	return floatex_comp(val,(PFLOATEX)n.val) > 0;
}

int			CFloatEX::operator<=(const CFloatEX &n)
{
	return floatex_comp(val,(PFLOATEX)n.val) <= 0;
}

int			CFloatEX::operator>=(const CFloatEX &n)
{
	return floatex_comp(val,(PFLOATEX)n.val) >= 0;
}

int			CFloatEX::operator==(const double n)
{
	CFloatEX	temp = n;

	return *this == temp;
}

int			CFloatEX::operator!=(const double n)
{
	CFloatEX	temp = n;

	return *this != temp;
}

int			CFloatEX::operator<(const double n)
{
	CFloatEX	temp = n;

	return *this < temp;
}

int			CFloatEX::operator>(const double n)
{
	CFloatEX	temp = n;

	return *this > temp;
}

int			CFloatEX::operator<=(const double n)
{
	CFloatEX	temp = n;

	return *this <= temp;
}

int			CFloatEX::operator>=(const double n)
{
	CFloatEX	temp = n;

	return *this >= temp;
}

int			CFloatEX::operator!(void)
{
	return !floatex_nzero(val);
}
