#include "cfloatex.h"

CFloatEX		CFloatEX::abs(void)
{
	CFloatEX	temp;

	floatex_eabs(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::nabs(void)
{
	CFloatEX	temp;

	floatex_enabs(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::chsign(void)
{
	CFloatEX	temp;

	floatex_echsign(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::copysign(const CFloatEX &n)
{
	CFloatEX	temp;

	floatex_copysign(val,(PFLOATEX)n.val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::integer(void)
{
	CFloatEX	temp;

	floatex_eint(val,temp.val);
	return temp;
}

int				CFloatEX::sgn(void)
{
	return floatex_sgn(val);
}

CFloatEX		CFloatEX::nextafter(const CFloatEX &y)
{
	CFloatEX	temp;

	floatex_nextafter(val,(PFLOATEX)y.val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::fval(int neg,UINT64 mant,int base,int exp)
{
	floatex_fval(neg,mant,base,exp,val);
	return *this;
}

CFloatEX		CFloatEX::qnan(UINT64 mant)
{
	floatex_qnan(mant,val);
	return *this;
}

CFloatEX		CFloatEX::snan(UINT64 mant)
{
	floatex_snan(mant,val);
	return *this;
}

