#include "cfloatex.h"

CFloatEX		CFloatEX::sin(void)
{
	CFloatEX	temp;

	floatex_sin(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::cos(void)
{
	CFloatEX	temp;

	floatex_cos(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::tan(void)
{
	CFloatEX	temp;

	floatex_tan(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::asin(void)
{
	CFloatEX temp;

	floatex_asin(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::acos(void)
{
	CFloatEX	temp;

	floatex_acos(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::atan(void)
{
	CFloatEX	temp;

	floatex_atan(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::sinh(void)
{
	CFloatEX	temp;

	floatex_sinh(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::cosh(void)
{
	CFloatEX	temp;

	floatex_cosh(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::tanh(void)
{
	CFloatEX	temp;

	floatex_tanh(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::asinh(void)
{
	CFloatEX	temp;

	floatex_asinh(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::acosh(void)
{
	CFloatEX	temp;

	floatex_acosh(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::atanh(void)
{
	CFloatEX	temp;

	floatex_atanh(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::sqrt(void)
{
	CFloatEX temp;

	floatex_sqrt(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::cbrt(void)
{
	CFloatEX temp;

	floatex_cbrt(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::exp(void)
{
	CFloatEX	temp;

	floatex_exp(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::ln(void)
{
	CFloatEX	temp;

	floatex_ln(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::log(void)
{
	CFloatEX	temp;

	floatex_log(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::log2(void)
{
	CFloatEX	temp;

	floatex_log2(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::logxy(const CFloatEX &n)
{
	CFloatEX	temp;

	floatex_logxy(val,(PFLOATEX)n.val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::pow(const CFloatEX &n)
{
	CFloatEX	temp;

	floatex_pow(val,(PFLOATEX)n.val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::pow2(void)
{
	CFloatEX	temp;

	floatex_pow2(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::pow10(void)
{
	CFloatEX	temp;

	floatex_pow10(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::hypot(const CFloatEX &n)
{
	CFloatEX	temp;

	floatex_hypot(val,(PFLOATEX)n.val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::floor(void)
{
	CFloatEX	temp;

	floatex_floor(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::ceil(void)
{
	CFloatEX	temp;

	floatex_ceil(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::jn(int n)
{
	CFloatEX	temp;

	floatex_jn(n,val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::yn(int n)
{
	CFloatEX	temp;

	floatex_yn(n,val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::gamma(void)
{
	CFloatEX	temp;

	floatex_gamma(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::fact(void)
{
	CFloatEX	temp;

	floatex_fact(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::dist_normal_u(void)
{
	CFloatEX	temp;

	floatex_dist_normal_u(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::dist_normal_d(void)
{
	CFloatEX	temp;

	floatex_dist_normal_d(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::dist_t_u(int n)
{
	CFloatEX	temp;

	floatex_dist_t_u(n,val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::dist_t_d(int n)
{
	CFloatEX	temp;

	floatex_dist_t_d(n,val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::dist_chi_u(int n)
{
	CFloatEX	temp;

	floatex_dist_chi_u(n,val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::dist_chi_d(int n)
{
	CFloatEX	temp;

	floatex_dist_chi_d(n,val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::dist_f_u(int n1,int n2)
{
	CFloatEX	temp;

	floatex_dist_f_u(n1,n2,val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::dist_f_d(int n1,int n2)
{
	CFloatEX	temp;

	floatex_dist_f_d(n1,n2,val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::atan(const CFloatEX &x,const CFloatEX &y)
{
	floatex_atan2((PFLOATEX)x.val,(PFLOATEX)y.val,val);
	return *this;
}

CFloatEX		CFloatEX::logxy(const CFloatEX &x,const CFloatEX &y)
{
	floatex_logxy((PFLOATEX)x.val,(PFLOATEX)y.val,val);
	return *this;
}

CFloatEX		CFloatEX::pow(const CFloatEX &x,const CFloatEX &y)
{
	floatex_pow((PFLOATEX)x.val,(PFLOATEX)y.val,val);
	return *this;
}

CFloatEX		CFloatEX::hypot(const CFloatEX &x,const CFloatEX &y)
{
	floatex_hypot((PFLOATEX)x.val,(PFLOATEX)y.val,val);
	return *this;
}

CFloatEX		CFloatEX::distance(
					const CFloatEX &x1,const CFloatEX &y1,
					const CFloatEX &x2,const CFloatEX &y2)
{
	floatex_distance(
		(PFLOATEX)x1.val,(PFLOATEX)y1.val,
		(PFLOATEX)x2.val,(PFLOATEX)y2.val,
		val);
	return *this;
}

CFloatEX		CFloatEX::lcm(const CFloatEX &x,const CFloatEX &y)
{
	floatex_lcm((PFLOATEX)x.val,(PFLOATEX)y.val,val);
	return *this;
}

CFloatEX		CFloatEX::gcm(const CFloatEX &x,const CFloatEX &y)
{
	floatex_gcm((PFLOATEX)x.val,(PFLOATEX)y.val,val);
	return *this;
}

CFloatEX		CFloatEX::permutation(const CFloatEX &x,const CFloatEX &y)
{
	floatex_permutation((PFLOATEX)x.val,(PFLOATEX)y.val,val);
	return *this;
}

CFloatEX		CFloatEX::combination(const CFloatEX &x,const CFloatEX &y)
{
	floatex_combination((PFLOATEX)x.val,(PFLOATEX)y.val,val);
	return *this;
}
