#include <windows.h>
#include "floatex.h"
#include "const_cnv.h"
#include "resource.h"

VOID	copy_clipboard(HWND hWnd)
{
	HANDLE		hMem,hRet;
	INT			len;

	if ((len = GetWindowTextLength(GetDlgItem(hWnd,IDC_EDIT2))) == 0 ||
		OpenClipboard(hWnd) == FALSE)
		return;

	EmptyClipboard();
	if (!(hMem = GlobalAlloc(GHND,++len))){
		CloseClipboard();
		return;
	}

	if (!GetDlgItemText(hWnd,IDC_EDIT2,GlobalLock(hMem),len)){
		GlobalFree(hMem);
		CloseClipboard();
		return;
	}

	hRet = SetClipboardData(CF_TEXT,hMem);
	GlobalUnlock(hMem);
	CloseClipboard();

	if (hRet)
		MessageBeep(MB_OK);
	else
		GlobalFree(hMem);
}

